/*
 * Variablen
 * Define's
 * Prototypen
 *
 * Created: 18.08.2016 10:35:44
 */ 




/* Variablen deklarieren */
volatile unsigned char Ueberschreitungen = 0;	// Anzahl Ueberschreitungen
												// der Spannung
volatile unsigned char Unterschreitungen = 0;	// Anzahl Unterschreitungen
												// der Spannung
volatile unsigned char Band = 5;				// maximale Anzahl Ueber-
												// oder Unterschreitungen
												
volatile unsigned char maximaler_spannungswert = 0;	
												// Wert vom Slave fuer
												// ermittelten Spitzenwert
volatile float relaer_Spannungswert;			// umgerechneter ermittelter
												// Effektivwert der Spannung
												// der Spannung
unsigned char gewuenschter_Spannungswert = 165;	// 230V Effektivwert (AC),
												// 325V Spitze
												// 5V enspricht 255
												// 3,25 entspricht 165
unsigned char Verhaeltnis = 100;				// Wert fuer Umrechnung von
												// Spitzen- auf Effektivwert
												
float Wurzel2 = 1.414213562371;

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
// Mein Problem hier ist, dass jeder Kunde eine andere Ansprechschwelle haben will und die das selber
// einstellen knnen wollen. Da ich die keine Hexzahlen ausrechnen lassen kann oder jedesmal den Controller
// selbst im Code ndern muss, muss es sich um einen Wert handeln, mit dem die umgehen knnen. Also eine Prozentangabe.
// Eventuell will der Kunde whrend der Laufzeit den Wert ndern. Wie kann ich jetzt Ein Toleranzband mit dem Character berechnen? 
volatile unsigned char Toleranz_oben = 10;		// Angabe in Prozent
volatile unsigned char Toleranz_unten = 10;		// Angabe in Prozent
volatile unsigned char Toleranzgrenze_oben = 0;
volatile unsigned char Toleranzgrenze_unten = 0;
volatile unsigned int Toleranzgrenze_oben_berech = 0;
volatile unsigned int Toleranzgrenze_unten_berech = 0;

volatile unsigned int Ausregeln_rechts = 0;		// gibt an ob Motor am rechten
												// Endanschlag angekommen
												// Initialwert 2, da erst Daten
												// geholt werden mssen
volatile unsigned int Ausregeln_links = 0;		// gibt an ob Motor am linken
												// Endanschlag angekommen
												// Initialwert 2, da erst Daten
												// geholt werden mssen
volatile unsigned int Ausregeln_rechts_zu_weit = 1;
volatile unsigned int Ausregeln_links_zu_weit = 1;
												
volatile unsigned int starten = 0;				// um Regelung zu beginnen
volatile unsigned int Daten_holen = 0;			// um Daten zu holen

/* Ein Wert muss groeser sein als der andere! Welcher ist egal! */
volatile unsigned int delay_rechts = 500;		// Wartezeit veraenderbar?
volatile unsigned int delay_links = 300;		// Wartezeit veraenderbar

uint8_t		Data[1];
uint8_t		SlaveAddress = 0x50;
												
/* Define's */
#define BAUD 9600								// Baudrate


/* Controller laeuft mit 1 MHz */
#ifndef F_CPU
#define F_CPU 1000000UL							
#endif

/* I2C clock in Hz */
#define SCL_CLOCK  10000L						


/* Prototypen */
ISR (INT1_vect);
ISR (INT0_vect);